;;
;; utils.scm
;;
;; Various utilities so that no external libraries are needed.
;;
;; ISC License
;;
;; Copyright 2023 Brmlab, z.s.
;; Dominik Pantůček <dominik.pantucek@trustica.cz>
;;
;; Permission to use, copy, modify, and/or distribute this software
;; for any purpose with or without fee is hereby granted, provided
;; that the above copyright notice and this permission notice appear
;; in all copies.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
;; WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
;; WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
;; AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
;; CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
;; OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
;; NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
;; CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

(declare (unit utils))

(module
 utils
 (
  filter
  utils-tests!
  )

 (import scheme
	 (chicken base)
	 testing)

 ;; Returns a list with elements matching pred? predicate.
 (define (filter pred? lst)
   (let loop ((lst lst)
	      (res '()))
     (if (null? lst)
	 (reverse res)
	 (if (pred? (car lst))
	     (loop (cdr lst)
		   (cons (car lst) res))
	     (loop (cdr lst)
		   res)))))

 ;; Performs utils module self-tests.
 (define (utils-tests!)
   (run-tests
    utils
    (test-equal? filter (filter odd? '(1 2 3 4)) '(1 3))
    (test-equal? filter (filter odd? '(2 4)) '())
    ))

 )
